--                                                    Rolf Schrder 1999-12-26
--> Includefile linput.e     line input, returns      Mrkenweg 37
--                   values if possible,      21029 Hamburg, Germany
--              ver. 1.0     strings else.            r.schr@t-online.de
--
--  Language: EUPHORIA ver. 2.2
------------------------------------------------------------------------------
include graphics.e          -- video_config(), get_position()
include get.e               -- wait_key(), value()
------------------------------------------------------------------------------
--
global function linput(
--              
                      sequence seps,  -- Sequence of seperators; if equal {},
                      integer  fn)    -- Device number           look at 'seps'
--
--> return: If file input (fn > 0):
-->         sequence of line input parameters, were each parameter is
--          an element of the return-sequence, transformed by the value
--          function, if possible. If value() fails, the unchanged parameter
--          string is set. Returns atom -1 at EOF.
--          If keyboerd input (fn = 0):
--          the same as for file input except the case of ONE item
--          which can be transformed into an atom: only in this
--          case the atom will be returned!!
--
    object   x
    sequence cusposini, cuspos, videoinf
    sequence retur, sjunk
    integer  ws, len, ijunk

    if not length(seps) then    -- standart separators:
        seps = {' ',',',9}      -- Blank, Comma, Tab
    end if

    if fn = 0 then              -- Keyboard input!
      x = ""
      videoinf = video_config()
      cusposini = get_position()
      while 1 do
          ijunk = wait_key()
          cuspos = get_position()
          if ijunk = 13 then    -- ENTER
              exit
          elsif ijunk = 8 then  -- BACKSPACE
              if cuspos[2] > cusposini[2] then
                  position(cuspos[1],cuspos[2]-1)
                  puts(1," ")
                  position(cuspos[1],cuspos[2]-1)
                  x = x[1..length(x)-1]
              end if
          else
              if cuspos[2] != videoinf[4] then    -- end-of-line handling
                  x &= ijunk
                  puts(1,ijunk)
              end if
          end if
      end while
    else                            -- File input!
      x = gets(fn)
      if integer(x) then            -- EOF condition
          return x
      end if
      x = x[1..length(x)-1]         -- cut LF from end.
    end if
--
--  split into sequence of strings separated by seps:
--
    len = length(x)
    retur = {}
    if len > 0 then
      sjunk = ""
      ws = 0
      for i = 1 to len do           -- run over all string-chars:
        ijunk = x[i]
        if match({ijunk},seps) then -- "white spaces"
          if ws = 0 then
            if length(sjunk) > 0 then
              retur = append(retur,sjunk)
              sjunk = ""
            end if
            ws = 1
          end if
        else
          sjunk &= ijunk
          if i = len then
            retur = append(retur,sjunk) -- retur is sequence of objects
            exit
          end if
          ws = 0
        end if
      end for
    end if
--
--  Transform strings into possible values
--
    len = length(retur)
    for i = 1 to len do
      sjunk = value(retur[i])
      if sjunk[1] = GET_SUCCESS then    -- value created
        retur[i] = sjunk[2]
        if fn = 0 and len = 1 then  -- return atom if ONE number from keyboard!
          return retur[i]
        end if
      end if
    end for
    return retur
end function

------------------------------------------------------------------------------
