--                                                    Rolf Schrder 2001-02-28
--> LSTQD.EX  Calculate Testdata for LSTQ.EX          Mrkenweg 37
--                         ver. 2.20          21029 Hamburg, Germany
--  Language: EUPHORIA ver. 2.2                       r.schr@t-online.de
------------------------------------------------------------------------------
without warning
without type_check
include lstqd.e                 -- LSTQ-functions...
include linput.e                -- keyboard input
------------------------------------------------------------------------------
constant func    = { "A1+A2X+A3X^2/2!+...+AMX^(M-1)/(M-1)!",         -- 1
		     "A1L(X,0)+A2L(X,1)+A3L(X,2)+...+AML(X,M-1) " & -- 2
		       "(Leg. Polyn.)",
		     "A1T(X,0)+A2T(X,1)+A3T(X,2)+...+AMT(X,M-1) " & -- 3
		       "(Tsch. Polyn.)",
		     "A1+[j=2,M] Sj; with arg=floor(j/2)X it " &    -- 4
		       "follows for Sj:\n      if j even then " &
		       "Sj=AjCOS(arg) else Sj=AjSIN(arg).",
		     "A1+A2X+A3X^2+A4X^3+A5COS(X)+A6SIN(X) ",  -- 5
		     "[j=1,4] AjX^(j-1) + [j=5,M] Sj; with " &       -- 6
		       "arg=floor((j-3)/2)X it \n      " &
		       "follows for Sj: if j odd then Sj=AjCOS(arg) " &
		       "else Sj=AjSIN(arg).",
		     "Poisson",                                         -- 7
		     "Gau",                                            -- 8
		     "Rectangle",                                       -- 9
		     "Signum"}                                          --10
constant params  = { 0, 0, 0, 0, 6, 0, 0, 0, 0, 0} -- 0 means variable
--                                                      parameters
constant request = {"Selection            : ",
		    "Equations (N>1)      : ",
		    "Xmin                 : ",
		    "Xmax                 : ",
		    "Random Xi? (0|1)     : ",
		    "Std.dev.|Expect.(0) : ",
		    "Number of parameters : "}
------------------------------------------------------------------------------

procedure main()
--        
    integer  N, M, F, func_num, LO
    sequence filenam, command, result, A, sjunk
    atom     Xmin, Xmax, t1, sigma
--
    puts(1,"Data for Linear Least Square Solution (LSTQD) " &
	    "for the following functions:\n")
    puts(1, repeat('',79)&"\n")
    printf(1," %2d = %-19s\n", { 0, "Abort program"})
    for i1 = 1 to length(func) do
	printf(1," %2d = %-19s\n", { i1, func[i1]})
    end for
    puts(1, repeat('',79)&"\n")
    result = repeat(0,length(request))
    for i1 = 1 to length(request)-1 do
	puts(1,request[i1])
	result[i1] = linput({},0)
	puts(1,"\n")
	if i1 = 1 and result[1] = 0 then
	    abort(1)
	end if
    end for
    puts(1, repeat('',79)&"\n")
    func_num = result[1]
    N        = result[2]
    Xmin     = result[3]
    Xmax     = result[4]
    LO       = result[5]
    sigma    = result[6]
    if params[func_num] = 0 then
	puts(1,request[length(request)])
	M = linput({},0)
	puts(1,"\n")
    else
	M = params[func_num]
    end if
    filenam = "LSTQ.DAT"
    if Xmin = Xmax then
	puts(1,"Xmin equal Xmax! Abort.\n")
	abort(1)
    elsif Xmin > Xmax then
	t1 = Xmin
	Xmin = Xmax
	Xmax = t1
    end if
    A = {}
    if func_num < 7 then  -- Parameters neccessary for this functions!
	puts(1,"Enter parameter Ai:\n")
	for i1 = 1 to M do
	    sjunk = "A" & sprintf("%d",i1) & ": "
	    puts(1,sjunk)
	    A &= linput({},0)
	    puts(1,"\n")
	end for
    end if
    command = command_line()
    if length(command) > 2 then -- is there a file given via commandline?
	filenam = command[3]
    end if
    t1 = time()
    sjunk = "func" & sprintf("%d",func_num)
    F = routine_id(sjunk) -- select fkt. for designmatrix
    if F = -1 then
	puts(1,"Can't find selected function \"" & sjunk & "\" =\n"  &
						 func[func_num] & ". Abort.\n")
	abort(1)
    end if
    makefile( filenam, func_num, F, A, Xmin, Xmax, N, M, sigma, LO)
    printf( 1,"Calculation: %.2fsec.\n", time()-t1)
end procedure
------------------------------------------------------------------------------

main()

------------------------------------------------------------------------------
